BEGIN
  FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'SPERMISSION_OWNERS_V') LOOP
    EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM SPERMISSION_OWNERS_V';
  END LOOP;
   FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'SPERMISSION_OWNERS_V') LOOP
    EXECUTE IMMEDIATE 'DROP VIEW SPERMISSION_OWNERS_V';
  END LOOP;
END;
/

CREATE VIEW SPERMISSION_OWNERS_V AS
 SELECT rpo.is_user,
    rpo.owner_unique_id,
    rpo.permission,
        CASE
            WHEN rpo.is_user = 1 THEN suser.display_name
            WHEN rpo.is_user = 0 THEN sgroup.name
            ELSE NULL
        END AS owner_name
   FROM resolved_spermission_owner rpo
     LEFT JOIN suser ON suser.unique_user_id = rpo.owner_unique_id AND suser.effective = 1
     LEFT JOIN sgroup ON sgroup.unique_group_id = rpo.owner_unique_id AND sgroup.effective = 1;

GRANT SELECT ON igops.SPERMISSION_OWNERS_V TO ig_report_role;
CREATE PUBLIC SYNONYM SPERMISSION_OWNERS_V FOR igops.SPERMISSION_OWNERS_V;
